#!/usr/bin/perl
#######################
# pmb_reduce_bonds
#######################
$Bond_Scale=0.592;$fvdw=1.6;$Rvdw=3.7;
#######################
# Data Table
open BIN ,"< pmb_bonds.tbl";
open BOUT ,"> pmb_reduced_bonds.tbl";
#######################
# Informational Header
printf BOUT "{+PMB+++++++++++++++++++++++++++++++++++++++++++PMB+}\n";
printf BOUT "{+PMB+++ Bonds (E = %6.4f (kcal-A) / s^2 ) ++++PMB+}\n",$Bond_Scale;
printf BOUT "{+PMB+++++++++++++++++++++++++++++++++++++++++++PMB+}\n";
#######################
# Bond Data
while (<BIN>){
  if($_ =~ "bond") {
	@line=split(" ",$_);@Comment=split("!#",$_);$Comment[1]=~s/\n//g;
	@data=split("{",$Comment[1]);
	$atom1=$line[1]; $atom2=$line[2];
	$bond_length=$data[0]; $bond_sd=$data[1]/1000;if($bond_sd<=0.001){$bond_sd=0.005;$Comment[1]=$Comment[1]." ?BOnd SD?";}
	$Bond_Energy=$Bond_Scale/($bond_sd)**2;
	if($atom1=~/^C/ && $atom2=~/^C/){
		$Bond_Target=$bond_length-$fvdw/(2*$Bond_Energy)*($bond_length-$Rvdw)**4;
		$Comment[1]=$Comment[1]." !Reduced!";
		}
	else{$Bond_Target=$bond_length;}
	#DEBUG# print "Comment: ".$Comment[1]."\n";
  	#DEBUG# printf "\nBond %+4s %+4s   D=%6.3f  SD=%6.3f  Energy=%8.1f\n",$atom1,$atom2,$bond_length,$bond_sd,$Bond_Energy;
  	printf BOUT "BOND %+4s %+4s %8.1f %6.3f !# %s\n",$atom1,$atom2,$Bond_Energy,$Bond_Target,$Comment[1];
	}}

close BIN;
#close BOUT;
exit;
###############################################################################
#######################
# pmb_PR
#######################
$na=0;$nnh=0;$nf=0;$naf;
open FIN ,"< Fobs.cv";
while (<FIN>){if($_ =~ "INDE") {@FOB=split("FOBS=",$_);$naf++;@SFOB=split("SIGMA=",$_);if($FOB[1]>2*$SFOB[1]){$nf++;} }};close FIN;
open AIN ,"< minimize.pdb";while (<AIN>){if($_ =~ "ATOM ") {$na++;if($_!~/ H[ ,A-Z,0-9]/){$nnh++;}}};close AIN;
$stereoflag= $nf/$nnh*3.344-6.4;$stereoflag=($stereoflag<3)?3:$stereoflag;
$stereoflag=($stereoflag>25)?22:$stereoflag;
printf " PR= %d    #Refl(F>2s)= %d   #NonH= %d    #Refl(all)=%d    #Atoms(all)=%d\n",$stereoflag,$nf,$nnh,$naf,$na;
exit;
###############################################################################
#sub Get_PROJ 
{
@proj=split("/", $ENV{PWD});foreach $dir (@proj){$PRJ=sprintf"%s",$dir}
$PRJ=~ s/[ ,\@,\\,\/,\~,\n]//g;
# DEBUG#
printf "REFINEMENT ID: %s   \tPROJECT: %s \n",$ID,$PRJ;
}
exit;
#
$time=localtime;
#DEBUG# print "Localtime:".$time."\n";
# Mon May  8 15:17:18 2006 #
@Dates=split(" ",localtime );
($Date=sprintf("%2d%s%2d%s",$Dates[4],$Dates[1],$Dates[2],$Dates[3]))=~s/://g;
$Year=$Dates[4]-2000; $Day=$Dates[2];
@HHMMSS=split(":",$Dates[3] );
$Hour=$HHMMSS[0];$Min=$HHMMSS[1];$Sec=$HHMMSS[2];
if   ($Dates[1]=~/Jan/) {$Month=1;}
elsif($Dates[1]=~/Feb/) {$Month=2;}
elsif($Dates[1]=~/Mar/) {$Month=3;}
elsif($Dates[1]=~/Apr/) {$Month=4;}
elsif($Dates[1]=~/May/) {$Month=5;}
elsif($Dates[1]=~/Jun/) {$Month=6;}
elsif($Dates[1]=~/Jul/) {$Month=7;}
elsif($Dates[1]=~/Aug/) {$Month=8;}
elsif($Dates[1]=~/Sep/) {$Month=9;}
elsif($Dates[1]=~/Oct/) {$Month=10;}
elsif($Dates[1]=~/Nov/) {$Month=11;}
else {$Month=12;}
########################################
# SET DATE STAMP # chr(65)=A,chr(97)=a # 
$ID=sprintf("%.2d%.2d%.2d%s",$Month,$Day,$Hour,chr(97+$Min/5));
#DEBUG# print " Date= $Date      ID=$ID\n";
########################################
########################################
########################################
# SET DATE STAMP # chr(65)=A,chr(97)=a # 
########################################
@Dates=split(" ",$Registration_Time);($Date=sprintf("%2d%s%2d%s",$Dates[4],$Dates[1],$Dates[2],$Dates[3]))=~s/://g; #DEBUG# print " ### Day = $Registration_Time ### Date= $Date ###<br>";
system "date +\"%m%d%H %M\" > .tmp ";
open IN, "< .tmp";
#while(<IN>){@date=split(" ", $_);$ID=sprintf"%s_%s",$date[0],chr(65+$date[1]/10);}
while(<IN>){@date=split(" ", $_);$ID=sprintf"%s%s",$date[0],chr(97+$date[1]/10);}
close IN;
#DEBUG# 
print " Date= $Date      ID=$ID\n";
#######################
exit;
