;################################################
;#               HBONDS-VU.SCM                  #
;################################################
;# Read hbonds.vu into COOT                     #
;# Thanks to Paul Emsley                        #
;# See "pmb_refine -b"                          #
;# http://xray.utmb.edu/PMB/PMB.html#pmb_refine #
;################################################

;##########################
(define colour-from-number
  (lambda (coln)
    (cond 
     ((<= coln 10) "white") 
     ((<= coln 40) "green") 
     ((<= coln 90) "red") 
     ((> coln 90) "green") 
    )
  ))
;##########################
(define read-vu-file
  (lambda (filename obj-name)

    (call-with-input-file filename
      (lambda (port)

	(let ((bnd  (new-generic-object-number obj-name)  ))
	
	(let loop ((dline (read port))
		   (current-line '()))

	  (cond 
	   ((eof-object? dline) 
	    (set-display-generic-object bnd 1))
	   ((= (length current-line) 6)
	    (let ((colour (colour-from-number dline)))
	      (apply to-generic-object-add-line 
		     (append (list bnd colour 2) (reverse current-line))))
	    (loop (read port) '()))
	   (else 
	    (loop (read port) (cons dline current-line))
           ))
       ))))))
;##########################
(read-vu-file "hbonds.vu" "hbonds")


