#!/usr/bin/perl
##########################################################################
# (c) 2000 Mark A. White, SCSB UTMB at Galveston
##########################################################################

if (@ARGV < 1) {
	die "usage: pmb_cns2phs.pl <CNS.cv> ";}
#if ($ARGV[1] <2 || $ARGV[2] > 500) {$Bfactor=20;}
#else {$Bfactor=$ARGV[1];}
#$A=$ARGV[2];$B=$ARGV[3];$C=$ARGV[4];

################################# Define Constants
$DTR=0.017453293;
################################# Open FILES
open IN ,"< ".$ARGV[0];

open CV   ,"> new.cv";
open PHS  ,"> new.phs";
open DF   ,"> new.df";
open PHSS ,"> new_s.phs";

while (<IN>) {
      @line1=split(" ",($line=$_));
      if($line1[0] =~ "INDE" ) {
# INDE     0    0    2 FOBS=     1.643     0.000 SIGMA=     2.773 TEST=         0
	$H=$line1[1];$K=$line1[2];$L=$line1[3];$line1[0]="INDEx ";
	$Fo=$line1[5];$pFo=$line1[5];$sF=$line1[8];$test=$line1[10];
#                   FCALC=     0.000     0.000 FBULK=   978.469   180.000
	$_=<IN>;
	@line2=split(" ",($line=$_));print CV $line;
	$Fc=$line2[1];$pFc=$line2[2];$Fb=$line2[4];$pFb=$line2[5];
	$_=<IN>;
	@line3=split(" ",($line=$_));print CV $line;
	$use_ref=$line3[1];$use_test=$line3[3];

#	if ($Bfactor!=0 ){
#	 $stl2=0.25*(($H/$A)**2 +($K/$B)**2+($L/$C)**2);
#	 $line1[5]*=10.0*exp(-$Bfactor*$stl2);
#	 $line1[5]+=20.0*3*4*(0.5-rand(0))*(0.5-rand(0));
#	 if($line1[5] < 0) {$line1[5]=10*rand(0)*rand(0);} 
#	}
	$line=" ".$line1[0];
	$line.=" ".$line1[1];$line.=" ".$line1[2];$line.=" ".$line1[3];
	$line.=" ".$line1[4];$line.=" ".$line1[5];$line.=" ".$line1[6];
	$line.=" ".$line1[7];$line.=" ".$line1[8];$line.=" ".$line1[9];
	$line.=" ".$line1[10];
	########################################## PHASE
	$Fx=$Fc*cos($pFc*$DTR)+$Fb*cos($pFb*$DTR);
	$Fy=$Fc*sin($pFc*$DTR)+$Fb*sin($pFb*$DTR);

	$Phase=atan2($Fy,$Fx)/$DTR;
		
	$FC= sqrt( ($Fx)**2 + ($Fy)**2 );
	########################################## OUTPUT
	print CV $line,"\n";
	printf PHS "%4d %4d %4d %10.3f %10.3f %10.3f \n", $H,$K,$L,$Fo,$FC,$Phase ;
	printf DF "%4d %4d %4d %10.3f 1.0 %10.3f 1.0 %10.3f 1.0 %10.3f 1.0\n", 
		$H,$K,$L,$Fo,0,$Fo,$Fo*0.9 ;
	if($test==0) {$test=1}
	else {$test=0}
	printf PHSS "%4d %4d %4d %10.3f %10.3f %10.3f %10.3f %4d\n", $H,$K,$L,$Fo,$sF,$FC,$Phase,$test ;
	
	if ($H==$L && $K==0 || $FC==0){
	  printf "%4d %4d %4d Fc= %10.2f, phase= %9.3f \n",$H,$K,$L,$Fc,$pFc ;
	  printf "               Fb= %10.2f, phase= %9.3f \n",$Fb,$pFb ;
	  printf "               FC= %10.2f, phase= %9.3f \n",$FC,$Phase ;
	  }
      }
#else {print CV $line;}
}

printf "########\n Local Scale not yet implemented \n########\n";
stop;

#!/bin/sh
# THis is a shell script
# ccp4_setup
# f2mtz HKLIN new_s.phs HKLOUT new_s.mtz << f2mtz_eof
#TITLE   MTZ from PHSS  10CRP From FoFc_calc.inp -> pmb_cns2phs.pl
#PNAME   CRP D53H
#DNAME   10CRP
##CELL   46.262  93.343  105.339 # angles default to 90 #10CRP
#CELL   46.028  93.024  105.503 # angles default to 90 #119CRP
#LABOUT   H  K  L  FO    SIGFO    FC     PHIC
#CTYPout  H  H  H  F     Q        F      P
#FORMAT '(3F5.0,4F11.3)'
#SYMM 19
#f2mtz_eof

#######This does not work 
#cad HKLIN new_s.mtz HKLOUT new_ss.mtz <<  cad_eof
#CELL   46.262  93.343  105.339 # angles default to 90
#SYMM 19
#LABIN    H  K  L  FO    SIGFO    FC     PHIC
#LABOUT   H  K  L  FO    SIGFO    FC     PHIC
#CTYPE    H  H  H  F     Q        F      P
#END
#cad_eof


# sigmaa HKLIN new_s.mtz HKLOUT new_sa.mtz << simaa_eof > sigmaa_log.html
#TITLE   SIGMAA m*Fo-Fc map  10CRP From FoFc_calc.inp -> pmb_cns2phs.pl
#TITLE   SIGMAA m*Fo-Fc map  119CRP From FoFc_calc.inp -> pmb_cns2phs.pl
###RESOLUTION 500.0 1.9 ! Resolution limits in Angstroms
#RANGES   20 5000     ! Number of bins for analysis v. resolution 
####                  ! Monitor every 5000th reflection
#PARTIAL              ! Option for difference map coefficients
#ERROR                ! Use sigmaA v resolution for coordinate error
#LABIN   FP=FO  SIGFP=SIGFO  FC=FC  PHIC=PHIC
#END
#simaa_eof

#RESOLVE
##############
#mtz2various HKLIN 10CRP_mFo-Fc_LS_ps.mtz HKLOUT 10CRP_mFo-Fc_LS_ps.phs << mtz2_eof
#LABIN FP=FP FOM=FOMM PHIC=PHIM 
#OUTPUT USER '(3I5,3F10.3)' 
#mtz2_eof
##############
#
