#!/usr/bin/perl
#######################
# pmb_hbond
#######################
use Math::Trig;
$na=0;$nnh=0;$HB_l=0;$HB_n=0;
$DMIN=2.4; $DMAX=3.6; $ANG_CUT=110; $DIHE_CUT=40; #Selection Criteria
$HBOND_D=2.90 ; $HBOND_LL=0.4 ; $HBOND_UL=0.7 ; $HBOND_SCALE=75; # NOES
#$kimpr_hbonds=5000; $dihe_angle_a=-10; $dihe_angle_b= 0 ; $dihe_well= 5; #Dihedrals
$kimpr_hbonds= 150; $dihe_angle_a= 10; $dihe_angle_b= 0 ; $dihe_well= 0; #Dihedrals
$D_STEP=0.1; # For Statisitics histogram
$NBINS=($DMAX-$DMIN)/$D_STEP;$MAX_BARS=50;
open AIN ,"< minimize.pdb";    #Input PDB
#open IIN ,"< HBONDS.LIST";     #User HBOND list
open VOUT ,"> hbonds.vu";      #Xfit VU file
# NOE Restraints #
open NOUT ,"> pmb_hbonds.def";      #NOE# NOE restraints
open DOUT ,"> pmb_hbdihe.def";      #NOE# Dihedral restraints
# Dihedral Restraints #
###open NOUT ,"> pmb_hbnoes.def";    #DIHE# NOE restraints
###open DOUT ,"> pmb_hbonds.def";    #DIHE# Dihedral restraints
#
#######################
#Read Atoms into array
$nnh=0;$na=0;
while (<AIN>){
if($_ =~ "ATOM ") {
	if($_!~/ H[ ,A-Z,0-9]/){$nnh++;}
	@line=split(" ",$_);
	#  0      1    2   3   4  5        6      7       8      9     10        11 #
	#ATOM   1920  CA  GLU D  55       7.896 -10.299  22.198  1.00 64.99      D
	$atom_name[$na]=$line[2];$atom_aa[$na]=$line[3];
	#  0      1    2   3      4       5       6      7       8      9        10 #
	#ATOM   1920  CA  GLU    55       7.896 -10.299  22.198  1.00 64.99      D
	if($line[4]=~/[A-Z,a-z]/){
		$atom_chain[$na]=$line[4];$atom_resid[$na]=$line[5];
		$atom_x[$na]=$line[6];$atom_y[$na]=$line[7];$atom_z[$na]=$line[8];}
	else{
		$atom_chain[$na]=" ";$atom_resid[$na]=$line[5-1];
		$atom_x[$na]=$line[6-1];$atom_y[$na]=$line[7-1];$atom_z[$na]=$line[8-1];}	
	$na++;
	}};close AIN;
#
printf "{#PMB_HBONDS# Read  %d  Atoms ( %d Non-H)                    #}\n",$na,$nnh;
#
$NBONDS_EST=100*(1+int($na/700));
print NOUT <<EOP;
flags include noe end
{# NOE HBOND PARAMETERS #}
noe
   nres=$NBONDS_EST
   class hres
   ceiling=1000
   averaging hres cent

   {* potential hres softsquare
   sqconstant hres 1.
   sqexponent hres 2 *}

   potential hres biharmonic
   scale hres $HBOND_SCALE
 end
{# NOE HBOND LIST #}
NOE
set message=off echo=off end
EOP
#
printf DOUT "restraints dihedral\n     nassign=%d\n\n",$NBONDS_EST;
printf DOUT "evaluate  ( \$kimpr_hbonds = %4.2f ) !#PMB#\n\n", $kimpr_hbonds;
#
$i=(0)-1;while (++$i<$na){
  if($atom_name[$i] eq "N" && $atom_aa[$i] ne "PRO"){
    #$j=($i+1)-1;while($atom_resid[$i]==$atom_resid[++$j] && $j<$na){};while (++$j<$na){
    $j=(0)-1;while (++$j<$na){
#    if($atom_name[$j] eq "O" && $atom_aa[$j] ne "HOH" && $atom_resid[$i]!=$atom_resid[$j] ){
    if($atom_name[$j] =~/O/ && $atom_aa[$j] ne "HOH" && $atom_resid[$i]!=$atom_resid[$j] ){
        $d=sqrt(($atom_x[$i]-$atom_x[$j])**2 +($atom_y[$i]-$atom_y[$j])**2 +($atom_z[$i]-$atom_z[$j])**2 );

	#Angle N...O=C   ($i , $j, $j-1)  also (ASP, ASN) N...OE1-CD,  (GLU,GLN) N...OD1-CG, (TYR)  N...OH-CZ,  (SER) N...OG-CB, (THR) N...OG1-CB 
	$Ax=$atom_x[$i]-$atom_x[$j]; $Bx=$atom_x[$j]-$atom_x[$j-1];
	$Ay=$atom_y[$i]-$atom_y[$j]; $By=$atom_y[$j]-$atom_y[$j-1];
	$Az=$atom_z[$i]-$atom_z[$j]; $Bz=$atom_z[$j]-$atom_z[$j-1];
	$angle=180.0-rad2deg(acos(($Ax*$Bx+$Ay*$By+$Az*$Bz)/(sqrt($Ax**2+$Ay**2+$Az**2)*sqrt($Bx**2+$By**2+$Bz**2))));

	#Angle (ASP) N...OE2-CD OR (GLU) N...OD2-CG
	if($atom_name[$j] =~ /O.2/ ){
	$Ax=$atom_x[$i]-$atom_x[$j]; $Bx=$atom_x[$j]-$atom_x[$j-2];
	$Ay=$atom_y[$i]-$atom_y[$j]; $By=$atom_y[$j]-$atom_y[$j-2];
	$Az=$atom_z[$i]-$atom_z[$j]; $Bz=$atom_z[$j]-$atom_z[$j-2];
	$angle=180.0-rad2deg(acos(($Ax*$Bx+$Ay*$By+$Az*$Bz)/(sqrt($Ax**2+$Ay**2+$Az**2)*sqrt($Bx**2+$By**2+$Bz**2))));
	}

	#Dihedral CA-N-C...O   ($i+1, $i, $k, $j)  (xfit Torsion N-Ca-C-O ~=0)
	$k=$i-1;while(($atom_resid[--$k]==$atom_resid[$i] || $atom_name[$k] ne "C" ) && $k>=0 && $atom_chain[$i] eq $atom_chain[$k] ){}
	$Ax=$atom_x[$i+1]-$atom_x[$i]; $Bx=$atom_x[$k]-$atom_x[$i]; $Cx=$atom_x[$j]-$atom_x[$i]; $Dx=$atom_x[$k]-$atom_x[$i+1]; 
	$Ay=$atom_y[$i+1]-$atom_y[$i]; $By=$atom_y[$k]-$atom_y[$i]; $Cy=$atom_y[$j]-$atom_y[$i]; $Dy=$atom_y[$k]-$atom_y[$i+1];
	$Az=$atom_z[$i+1]-$atom_z[$i]; $Bz=$atom_z[$k]-$atom_z[$i]; $Cz=$atom_z[$j]-$atom_z[$i]; $Dz=$atom_z[$k]-$atom_z[$i+1];
	$ABx=$Ay*$Bz-$Az*$By; $ABy=$Az*$Bx-$Ax*$Bz; $ABz=$Ax*$By-$Ay*$Bx;
	#$BCx=$By*$Cz-$Bz*$Cy; $BCy=$Bz*$Cx-$Bx*$Cz; $BCz=$Bx*$Cy-$By*$Cx;
	$DCx=$Dy*$Cz-$Dz*$Cy; $DCy=$Dz*$Cx-$Dx*$Cz; $DCz=$Dx*$Cy-$Dy*$Cx;
	$ABDC=sqrt($ABx**2+$ABy**2+$ABz**2)*sqrt($DCx**2+$DCy**2+$DCz**2);
	if($ABDC!=0) {$dihe=rad2deg(acos(($ABx*$DCx+$ABy*$DCy+$ABz*$DCz)/($ABDC)));}else {$dihe=180;}

	#These are real H-bonds * per our selection criteria
	if($d <= $DMAX && $d >= $DMIN && $angle >$ANG_CUT && $dihe < $DIHE_CUT){
	  # Target Angles ALPHA-helix or other #
	  if($atom_name[$j] eq "O" && $atom_resid[$i]==$atom_resid[$j]+4 || $atom_resid[$i]==$atom_resid[$j]+3) {$dihe_target=$dihe_angle_a;}else{$dihe_target=$dihe_angle_b;}
	  # HBONDS.DEF NOE assignments #
	  printf NOUT "assign (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) %4.2f %4.1f %4.1f !#PDB %4.2f %5.0f %5.0f\n",$atom_chain[$i],$atom_resid[$i],$atom_name[$i],$atom_chain[$j],$atom_resid[$j],$atom_name[$j],$HBOND_D,$HBOND_LL,$HBOND_UL,$d,$angle,$dihe;
	  printf DOUT "assign (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) \$kimpr_hbonds  %4.2f  %6.1f   2    !#PDB %4.2f %5.0f %5.0f\n",$atom_chain[$i],$atom_resid[$i],$atom_name[$i], $atom_chain[$i+1],$atom_resid[$i+1],$atom_name[$i+1], $atom_chain[$k],$atom_resid[$k],$atom_name[$k], $atom_chain[$j],$atom_resid[$j],$atom_name[$j],$dihe_target,$dihe_well,$d,$angle,$dihe;
#	  printf DOUT "assign (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) \$kimpr_hbonds  %4.2f  -180.0   2    !#PDB %4.2f %5.0f %5.0f\n",$atom_chain[$i],$atom_resid[$i],$atom_name[$i], $atom_chain[$i+1],$atom_resid[$i+1],$atom_name[$i+1], $atom_chain[$k],$atom_resid[$k],$atom_name[$k], $atom_chain[$j],$atom_resid[$j],$atom_name[$j],0,$d,$angle,$dihe;
#	  printf DOUT "assign (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) (segid %s and resid %4d and name %s) \$kimpr_hbonds  %4.2f  -180.0   2    !#PDB %4.2f %5.0f %5.0f\n",$atom_chain[$i],$atom_resid[$i],$atom_name[$i], $atom_chain[$i+1],$atom_resid[$i+1],$atom_name[$i+1], $atom_chain[$k],$atom_resid[$k],$atom_name[$k], $atom_chain[$j],$atom_resid[$j],$atom_name[$j],0,$d,$angle,$dihe;
	  #For VUeing bonds in xfit honds.vu
	  if($dihe < $DIHE_CUT/1.3 && ($d < ($HBOND_D - $HBOND_LL/2) || $d > ($HBOND_D + $HBOND_UL/2)) ){
	    printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$i],$atom_y[$i],$atom_z[$i],$atom_x[$j],$atom_y[$j],$atom_z[$j],0; }
	  else{
	    printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$i],$atom_y[$i],$atom_z[$i],$atom_x[$j],$atom_y[$j],$atom_z[$j],92;}
	  #DEBUG# printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$i+1],$atom_y[$i+1],$atom_z[$i+1],$atom_x[$i],$atom_y[$i],$atom_z[$i],76; 
	  #DEBUG# printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$k],$atom_y[$k],$atom_z[$k],$atom_x[$i],$atom_y[$i],$atom_z[$i],80; 
	  #DEBUG# printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$j],$atom_y[$j],$atom_z[$j],$atom_x[$i],$atom_y[$i],$atom_z[$i],84; 
	  #DEBUG# printf VOUT "%6.3f %6.3f %6.3f   %6.3f %6.3f %6.3f %d\n",$atom_x[$k],$atom_y[$k],$atom_z[$k],$atom_x[$i+1],$atom_y[$i+1],$atom_z[$i+1],88; 
	  #For Statisitics
	  $HB_length[$HB_n]=$d; $HB_l+=$d; $HB_n++;$HB_a+=$angle;$HB_t+=$dihe;
	  if($d>=$DMAX-$D_STEP){$dmax_n++;}
	  if($d<=$DMIN+$D_STEP){$dmin_n++;}
	  $k=0;while($k++<$NBINS){if($d>=$DMIN+$k*$D_STEP && $d<$DMIN+($k+1)*$D_STEP){$bin_count[$k]++;if($bin_count[$k]>$bin_c_max){$bin_c_max=$bin_count[$k];}}}
	  }
        }
      } 
    }
  }
printf DOUT "    end\n\n";
close VOUT;
#Caclulate averages & Stats
if($HB_n>0){$HB_avg=$HB_l/$HB_n;$HB_sd=0;$i=0-1;while(++$i<$HB_n){$HB_sd+=sqrt(($HB_length[$i]-$HB_avg)**2);} }
printf "{# Found %d h-bonds Average dist=%6.3f (%5.3f)                    #}\n",$HB_n,$HB_avg,($HB_sd)/$HB_n;
printf "{#               Average angle=   %5.1f  Nmax=%d                     #}\n",$HB_a/$HB_n,$dmax_n;
printf "{#               Average torsion= %5.1f  Nmin=%d                     #}\n\n",$HB_t/$HB_n,$dmin_n;
#####         1         2         3         4         5         6         7         8
#####12345678901234567890123456789012345678901234567890123456789012345678901234567890
#####{# 3.00 - 3.10:      22 @@@@@@@@@@@@@@@@@@@@@@                             #}
if($bin_c_max>$MAX_BARS){$k=0-1;while(++$k<$NBINS){$bin_bars[$k]=$MAX_BARS*$bin_count[$k]/$bin_c_max;}}
	else{$k=0-1;while(++$k<$NBINS){$bin_bars[$k]=$bin_count[$k];}}
$k=0-1;while(++$k<$NBINS){
  #printf " %4.2f - %4.2f :%8d \n",$DMIN+$k*$D_STEP, $DMIN+($k+1)*$D_STEP,$bin_count[$k];
  printf "{# %4.2f - %4.2f:%8d ",$DMIN+$k*$D_STEP, $DMIN+($k+1)*$D_STEP,$bin_count[$k];
  	$i=-1;while(++$i < $bin_bars[$k]){printf "@";};while(++$i <= $MAX_BARS){printf " ";};printf " #}\n";
  }
printf "\n";
printf NOUT "\n";
printf NOUT "set message=on echo=on end\n";
printf NOUT "END\n";
#
close DOUT;
close NOUT;
exit;
